regina::NormalHypersurfaceVector Class Referenceabstract
Normal Hypersurfaces

Stores the vector of a single normal hypersurface in a 4-manifold triangulation. More...

`#include <hypersurface/normalhypersurface.h>`

Inheritance diagram for regina::NormalHypersurfaceVector:

## Public Member Functions

| NormalHypersurfaceVector (size_t length)
| Creates a new vector all of whose entries are initialised to zero. More...
| NormalHypersurfaceVector (const Vector< LargeInteger > &cloneMe)
| Creates a new vector that is a clone of the given vector. More...
virtual | ~NormalHypersurfaceVector ()
| A virtual destructor. More...
const Ray & | coords () const
| Gives read-only access to the underlying vector of coordinates. More...
virtual NormalHypersurfaceVector * | clone () const =0
| Creates a newly allocated clone of this vector. More...
size_t | size () const
| Returns the number of coordinates in the underlying vector. More...
const NLargeInteger & | operator[] (size_t index) const
| Returns the given coordinate from the underlying vector. More...
virtual void | setElement (size_t index, const LargeInteger &value)
| Sets the given normal coordinate to the given value. More...
virtual void | operator+= (const NormalHypersurfaceVector &other)
| Adds the given vector to this vector. More...
virtual void | scaleDown ()
| Scales this vector down by the greatest common divisor of all its elements. More...
virtual bool | isCompact (const Triangulation< 4 > *triang) const
| Determines if the normal hypersurface represented is compact (has finitely many pieces). More...
virtual bool | isVertexLinking (const Triangulation< 4 > *triang) const
| Determines if the normal hypersurface represented is vertex linking. More...
virtual const Vertex< 4 > * | isVertexLink (const Triangulation< 4 > *triang) const
| Determines if a rational multiple of the normal hypersurface represented is the link of a single vertex. More...
virtual const Edge< 4 > * | isThinEdgeLink (const Triangulation< 4 > *triang) const
| Determines if a rational multiple of the normal hypersurface represented is the thin link of a single edge. More...
virtual LargeInteger | tetrahedra (size_t pentIndex, int vertex, const Triangulation< 4 > *triang) const =0
| Returns the number of tetrahedron pieces of the given type in this normal hypersurface. More...
virtual LargeInteger | prisms (size_t pentIndex, int prismType, const Triangulation< 4 > *triang) const =0
| Returns the number of prism pieces of the given type in this normal hypersurface. More...
virtual LargeInteger | edgeWeight (size_t edgeIndex, const Triangulation< 4 > *triang) const =0
| Returns the number of times this normal hypersurface crosses the given edge. More...

## Static Public Member Functions

static NormalHypersurfaceVector * | makeZeroVector (const Triangulation< 4 > *triangulation)
| Returns a new normal hypersurface vector of the appropriate length for the given triangulation and for the coordinate system corresponding to this subclass of NormalHypersurfaceVector. More...
static MatrixInt * | makeMatchingEquations (const Triangulation< 4 > *triangulation)
| Creates a new set of normal hypersurface matching equations for the given triangulation using the coordinate system corresponding to this particular subclass of NormalHypersurfaceVector. More...
static EnumConstraints * | makeEmbeddedConstraints (const Triangulation< 4 > *triangulation)
| Creates a new set of validity constraints representing the condition that normal hypersurfaces be embedded. More...

## Protected Attributes

Ray | coords_
| The raw vector of normal coordinates. More...

## Detailed Description

Stores the vector of a single normal hypersurface in a 4-manifold triangulation.

The different subclasses of NormalHypersurfaceVector use different underlying coordinate systems for the normal solution space. However, the various coordinate retrieval routines will return values that are independent of the underlying coordinate system. Thus the coordinates of the normal hypersurface in any coordinate system can be determined without knowledge of the specific underlying coordinate system being used.

Note that non-compact hypersurfaces (surfaces with infinitely many pieces) are allowed; in these cases, the corresponding coordinate lookup routines should return LargeInteger::infinity where appropriate.

All subclasses of NormalHypersurfaceVector must have the following properties:

- Normal hypersurfaces can be enumerated by intersecting the non-negative orthant of the underlying vector space with some linear subspace;
- Adding two normal hypersurfaces corresponds to adding the two underlying vectors.

When deriving classes from NormalHypersurfaceVector:

- A new value must be added to the HyperCoords enum in hypercoords.h to represent the new coordinate system.
- The file hscoordregistry-impl.h must be updated to reflect the new coordinate system (the file itself contains instructions on how to do this).
- A corresponding specialisation of HyperInfo<> must be defined, typically in the same header as the new vector subclass.
- The macro REGINA_NORMAL_HYPERSURFACE_FLAVOUR must be added to the beginning of the new vector subclass. This will declare and define various constants, typedefs and virtual functions (see the REGINA_NORMAL_HYPERSURFACE_FLAVOUR macro documentation for details).
- Constructors `class(size_t length)` and `class(const Vector<LargeInteger>& cloneMe)` must be declared and implemented; these will usually just call the corresponding superclass constructors.
- All abstract functions must be implemented, except for those already provided by REGINA_NORMAL_HYPERSURFACE_FLAVOUR. Note that coordinate functions such as tetrahedra() must return the total number of pieces of the requested type; if your new coordinate system adorns pieces with extra information (such as orientation) then your implementation must compute the appropriate sum.
- Static public functions `void makeZeroVector(const Triangulation<4>*)`, `MatrixInt* makeMatchingEquations(const Triangulation<4>*)` and makeEmbeddedConstraints(const Triangulation<4>*) must be declared and implemented.

Python:\n Not present.

The documentation for this class was generated from the following file:

- hypersurface/normalhypersurface.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).